#include "RipRenderer.h"
#include "RipData.h"
#include "AcidImage.h"


CRipRenderer::CRipRenderer() {


}


CRipRenderer::~CRipRenderer() {


}


void CRipRenderer::setImage(CImageContext *context, CImageData *data) {
	
}


int CRipRenderer::invalidateRect(CImageContext *context, CImageData *data, CRect rc, int &xoffs, int &yoffs) {

	if (context->m_recordMovie)
		return 0;

	xoffs = yoffs = 0;
	int ret = 1;
	CRipData *ripData = (CRipData *)data;
	if (ripData->hasCommands()) {
		ret =  invalidateRectAnimation(context, data, rc, xoffs, yoffs);
	} 

	if (ret) {		
		context->m_pDC->BitBlt(0, 0, rc.Width(), rc.Height(), ripData->m_pDC, rc.left, rc.top, SRCCOPY);		
	}
	return 0;
}


int CRipRenderer::invalidateRectAnimation(CImageContext *context, CImageData *data, CRect rc, int &xoffs, int &yoffs) {

	CRipData *ripData = (CRipData *)data;

	int count = 0;
	CRipCommandData command;
	while(ripData->getNextCommand(command)!=-1) {
		ripData->executeCommand(&command);
		count++;
	}

	return count;
}
